# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
from waptutils import get_sha256
from urllib.parse import urlparse, urljoin, quote


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url_base = "https://www.barco.com/en/products/clickshare-conferencing-collaboration/app"
    page = requests.get(url_base, proxies=proxies).text
    soup = BeautifulSoup.BeautifulSoup(page)
    end_url = soup.find('a',string=" Windows MSI ")['href'].split("/")[-1]
    url = f"https://www.barco.com/bin/barco/tde/downloadUrl.json?fileNumber={end_url}&tdeType=3"
    app_name = control.name
    zip_unzip = ".\zip_unzip"
    latest_bin = "ClickShare_Installer.msi"

    # Downloading latest binary
    print("URL used is: %s" % url)
    download_url = wgets(url, as_json=True)["downloadUrl"]
    wget(download_url, ".")

    bin_zip = glob.glob("*.zip")[0]
    unzip(bin_zip, zip_unzip)
    remove_file(bin_zip)
    filecopyto(makepath(zip_unzip,latest_bin), ".")
    remove_tree(zip_unzip)


    # Getting version from binary
    version = get_version_from_binary(latest_bin)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print(
            "Software version updated (from: %s to: %s)"
            % (control.get_software_version(), Version(version))
        )
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated
